// !a_charissa_reset
//
// Resets Charissa's level and levels her up.
//

#include "ginc_item"


void main()
{
	object oTarget = GetObjectByTag("kage"); // OBJECT_SELF, probly. This is executed from her SpawnScript. Not sure about anyplace else though.
	if (GetIsObjectValid(oTarget))
	{
		// Give Charissa the correct domains
		SetLevelUpPackage(oTarget, PACKAGE_CLERIC_BATTLE_PRIEST);

		// Reset Charissa to level
		ResetCreatureLevelForXP(oTarget, 0, FALSE);

		// Give Charissa 210000 EXP for player to level her
		SetXP(oTarget, 210000);

		IdentifyEquippedItems();
		IdentifyInventory();

		FeatAdd(oTarget, FEAT_POWER_ATTACK, FALSE);
		FeatAdd(oTarget, FEAT_LUCK_OF_HEROES, FALSE);
		FeatAdd(oTarget, FEAT_WEAPON_PROFICIENCY_MARTIAL, FALSE);
		FeatAdd(oTarget, FEAT_TOWER_SHIELD_PROFICIENCY, FALSE);

		// Remove Unwanted Feats from old Domains
		FeatRemove(oTarget, FEAT_DIVINE_RESISTANCE);
		FeatRemove(oTarget, FEAT_TRACK);

		int iHeal = GetMaxHitPoints(oTarget) - GetCurrentHitPoints(oTarget);
		if (iHeal > 0)
		{
			effect eHeal = EffectHeal(iHeal);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eHeal, oTarget);
		}
	}
}
