// !a_kaelyn_reset
//
// Resets Kaelyn's level and levels her up.
//

#include "ginc_item"

const int PACKAGE_KAELYN = 205;


void main()
{
	object oTarget = GetObjectByTag("kaelynthedove"); // OBJECT_SELF, probly. This is executed from her SpawnScript. Not sure about anyplace else though.
	if (GetIsObjectValid(oTarget))
	{
		// Give Kaeylyn the correct domains
		SetLevelUpPackage(oTarget, PACKAGE_KAELYN);

		// Reset Kaelyn to level
		ResetCreatureLevelForXP(oTarget, 0, FALSE);

		// Give Kaelyn 210000 EXP for player to level her
		SetXP(oTarget, 210000);

		IdentifyEquippedItems();
		IdentifyInventory();

		FeatAdd(oTarget, FEAT_ZEN_ARCHERY, FALSE);
		FeatAdd(oTarget, FEAT_WEAPON_PROFICIENCY_MARTIAL, FALSE);

		// Remove Unwanted Feats from old Domains
		FeatRemove(oTarget, FEAT_DIVINE_RESISTANCE);
		FeatRemove(oTarget, FEAT_TRACK);

		int iHeal = GetMaxHitPoints(oTarget) - GetCurrentHitPoints(oTarget);
		if (iHeal > 0)
		{
			effect eHeal = EffectHeal(iHeal);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eHeal, oTarget);
		}
	}
}
