// 'ac_antipathy'

#include "x2_inc_switches"
#include "nw_i0_2q4luskan"


void main()
{
	if (GetLocalInt(GetObjectByTag("antipathy"), "crypt_done") == TRUE)
		return;

	// Spells might continue to their spell scripts. All other events are
	// completely handled by this script.
	int nEvent = GetUserDefinedItemEventNumber();
	if (nEvent != X2_ITEM_EVENT_SPELLCAST_AT)
		SetExecutedScriptReturnValue();

	switch (nEvent)
	{
		case X2_ITEM_EVENT_ACTIVATE: // The item's CastSpell Activate or CastSpell UniquePower was just activated.
		{
			object		oItemUser	= GetItemActivator();
			object		oItem		= GetItemActivated();
			object		oTarget		= GetItemActivatedTarget();
			location	lTargetA	= GetLocation(GetNearestObjectByTag("wp_true_crypt"));
			location	lTargetB	= GetLocation(GetNearestObjectByTag("wp_true_door"));
			location	lTargetBB	= GetLocation(GetNearestObjectByTag("wp_crypt_door"));
			location	lTargetC	= GetLocation(GetNearestObjectByTag("wp_right_collide"));
			location	lTargetD	= GetLocation(GetNearestObjectByTag("wp_left_collide"));
			location	lTargetE	= GetLocation(GetNearestObjectByTag("wp_crypt_block_b"));
			location	lTargetF	= GetLocation(GetNearestObjectByTag("wp_closed_in"));

			if (!GetIsObjectValid(oItemUser) || !GetIsObjectValid(oItem))
			{
				SetExecutedScriptReturnValue(X2_EXECUTE_SCRIPT_CONTINUE);
				return;
			}

			// This is where you put your Unique power activation modifications.
			if (oTarget == GetObjectByTag("key_hole"))
			{
				if(GetDistanceBetween(oItemUser, GetObjectByTag("key_hole")) > 3.5f)
				{
					FloatingTextStringOnCreature("I cannot reach the Keyhole from here!", oItemUser);
					PlayVoiceChat(VOICE_CHAT_CANTDO, oItemUser);
					return;
				}

				CreateObject(OBJECT_TYPE_PLACEABLE, "crypt_block_2",	lTargetE);
				CreateObject(OBJECT_TYPE_PLACEABLE, "true_crypt",		lTargetA);
				CreateObject(OBJECT_TYPE_PLACEABLE, "true_crypt_door",	lTargetB);
				CreateObject(OBJECT_TYPE_PLACEABLE, "true_door",		lTargetBB);
				CreateObject(OBJECT_TYPE_PLACEABLE, "crypt_secret",		lTargetF);

				object oMover = GetFirstFactionMember(oItemUser);
				while (GetIsObjectValid(oMover))
				{
					AssignCommand(oMover, ActionMoveAwayFromLocation(lTargetC, TRUE, 2.5f));
					AssignCommand(oMover, ActionMoveAwayFromLocation(lTargetD, TRUE, 2.5f));

					oMover = GetNextFactionMember(oItemUser);
				}

				DelayCommand(0.5f, CreateObjectVoid(OBJECT_TYPE_PLACEABLE, "right_collide", lTargetC));
				DelayCommand(0.5f, CreateObjectVoid(OBJECT_TYPE_PLACEABLE, "left_collide",  lTargetD));

				oItemUser = GetFirstObjectInShape(SHAPE_CUBE, 9.5f, GetLocation(GetNearestObjectByTag("key_hole")), TRUE);

				while (GetIsObjectValid(oItemUser))
				{
					if (GetDistanceBetween(oTarget, oItemUser) <= 9.5f)
					{
						effect eDeath = EffectDeath();
						DelayCommand(2.5f, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDeath, oItemUser));
					}
					oItemUser = GetNextObjectInShape(SHAPE_CUBE, 9.5f, GetLocation(GetNearestObjectByTag("key_hole")), TRUE);
				}
				SendMessageToPC(GetFirstPC(), "The Crypt SLAMS DOWN from above - CRUSHING every one underneath");
			}

			DestroyObject(GetObjectByTag("key_hole"));
			DelayCommand(2.5, ExecuteScript("a_crypt_fill", OBJECT_SELF));

			SetLocalInt(GetObjectByTag("antipathy"), "crypt_done", TRUE);
		}
	}
}
