// 'ac_golden_key'

#include "x2_inc_switches"


void main()
{
	// Spells might continue to their spell scripts. All other events are
	// completely handled by this script.
	int nEvent = GetUserDefinedItemEventNumber();
	if (nEvent != X2_ITEM_EVENT_SPELLCAST_AT)
		SetExecutedScriptReturnValue();

	switch (nEvent)
	{
		case X2_ITEM_EVENT_ACTIVATE: // The item's CastSpell Activate or CastSpell UniquePower was just activated.
		{
			object		oItemUser	= GetItemActivator();
			object		oItem		= GetItemActivated();
			object		oTarget		= GetItemActivatedTarget();
			location	lTarget		= GetIsObjectValid(oTarget) ? GetLocation(oTarget) : GetItemActivatedTargetLocation();

			if (!GetIsObjectValid(oItemUser) || !GetIsObjectValid(oItem))
			{
				SetExecutedScriptReturnValue(X2_EXECUTE_SCRIPT_CONTINUE);
				return;
			}

			// This is where you put your Unique power activation modifications.
			if (oTarget == GetObjectByTag("key_hole"))
			{
				AssignCommand(oTarget, ActionCastSpellAtObject(SPELL_FIREBALL, oTarget, METAMAGIC_ANY, TRUE));
				ApplyEffectAtLocation(DURATION_TYPE_INSTANT, EffectAreaOfEffect(AOE_MOB_FIRE), GetLocation(GetObjectByTag("key_hole")));
			}
		}
	}
}
