// 'thirst_inc'

// based on MotB 'kinc_spirit_eater'

// === GUI ===
//const string BAR_CRAVINGBAR 				= "CRAVINGBAR"; 			// the craving bar element
//const string BAR_CRAVINGBAR_PAUSE			= "CRAVINGBAR_PAUSE";		// the craving bar element when paused
//const string BAR_CRAVINGBAR_BG			= "CRAVINGBAR_BG";			// the craving bar background
//const string BAR_CRAVINGBAR_BG_PAUSE		= "CRAVINGBAR_BG_PAUSE";	// the craving bar background when paused

// debug helper.
//void Tell(string tell) { SendMessageToPC(GetFirstPC(FALSE), tell); } // debug.


// ________________
// ** Constants ***
// ----------------

const string VAR_THIRST_INITIALIZED_b = "Thirst_initialized";

const string VAR_THIRST_POINTS_f = "Thirst_points";

const float THIRST_POINTS_START_f	= 100.f;
const float THIRST_POINTS_MAX_f		= 100.f;
const float THIRST_POINTS_MIN_f		=   0.f;

const float THIRST_HOURLY_DECAY_f = -2.f;

const string VAR_THIRST_PAUSED_b = "Thirst_paused";
const string VAR_THIRST_PAUSED_FORCE_b = "Thirst_paused_FORCED";


const string VAR_THIRST_STAGE_i	= "Thirst_stage";

// thirst points
const float THIRST_POINTS_STAGE_0_f = 65.f;
const float THIRST_POINTS_STAGE_1_f = 37.f;
const float THIRST_POINTS_STAGE_2_f = 17.f;
const float THIRST_POINTS_STAGE_3_f =  7.f;
const float THIRST_POINTS_STAGE_4_f =  2.f;
const float THIRST_POINTS_STAGE_5_f =  1.f;
//const float THIRST_POINTS_STAGE_6_f =  0.f;

// thirst stages
const int THIRST_STAGE_0_i = 0;
const int THIRST_STAGE_1_i = 1;
const int THIRST_STAGE_2_i = 2;
const int THIRST_STAGE_3_i = 3;
const int THIRST_STAGE_4_i = 4;
const int THIRST_STAGE_5_i = 5;
const int THIRST_STAGE_6_i = 6;

const int THIRST_EFFECT_ID = 23753; // arbitrary ID #.

const string VAR_THIRST_DEATH_b = "Thirst_death";


// GUI
const string VAR_THIRST_BAR_SCREEN_s		= "THIRST_BAR_SCREEN";
const string VAR_THIRST_BAR_FILE_s			= "THIRST_BAR_FILE";

const string SCREEN_GUI_THIRST_BAR_s		= "GUI_THIRST_BAR";
const string SCREEN_GUI_THIRST_BAR_MIN_s	= "GUI_THIRST_BAR_MIN";

const string FILE_GUI_THIRST_BAR_s			= "thirstbar.xml";
const string FILE_GUI_THIRST_BAR_MIN_s		= "thirstbar_min.xml";

const string BAR_THIRSTBAR					= "THIRSTBAR";
const string BAR_THIRSTBAR_PAUSE			= "THIRSTBAR_PAUSE";
const string BAR_THIRSTBAR_BG				= "THIRSTBAR_BG";
const string BAR_THIRSTBAR_BG_PAUSE			= "THIRSTBAR_BG_PAUSE";

const string BAR_THIRST_TEXT_PERCENT		= "THIRST_PERCENT_TEXT";

// these elements are actually buttons so that they can be disabled
// but they don't do anything and so they behave like plain icons.
//const string ICON_THIRST_STAGE_0_TOP = "ThirstLevel0_top";
const string ICON_THIRST_STAGE_1_TOP = "ThirstLevel1_top";
const string ICON_THIRST_STAGE_2_TOP = "ThirstLevel2_top";
const string ICON_THIRST_STAGE_3_TOP = "ThirstLevel3_top";
const string ICON_THIRST_STAGE_4_TOP = "ThirstLevel4_top";
const string ICON_THIRST_STAGE_5_TOP = "ThirstLevel5_top";
const string ICON_THIRST_STAGE_6_TOP = "ThirstLevel6_top";

//const string ICON_THIRST_STAGE_0 = "ThirstLevel0";
const string ICON_THIRST_STAGE_1 = "ThirstLevel1";
const string ICON_THIRST_STAGE_2 = "ThirstLevel2";
const string ICON_THIRST_STAGE_3 = "ThirstLevel3";
const string ICON_THIRST_STAGE_4 = "ThirstLevel4";
const string ICON_THIRST_STAGE_5 = "ThirstLevel5";
const string ICON_THIRST_STAGE_6 = "ThirstLevel6";

//const string ICON_THIRST_STAGE_0_GHOSTED = "ThirstLevel0_ghosted";
const string ICON_THIRST_STAGE_1_GHOSTED = "ThirstLevel1_ghosted";
const string ICON_THIRST_STAGE_2_GHOSTED = "ThirstLevel2_ghosted";
const string ICON_THIRST_STAGE_3_GHOSTED = "ThirstLevel3_ghosted";
const string ICON_THIRST_STAGE_4_GHOSTED = "ThirstLevel4_ghosted";
const string ICON_THIRST_STAGE_5_GHOSTED = "ThirstLevel5_ghosted";
const string ICON_THIRST_STAGE_6_GHOSTED = "ThirstLevel6_ghosted";


//
//const string SFX_THIRST_STAGE_INCREASE = "gui_mg_speattranup";
//const string SFX_THIRST_STAGE_DECREASE = "gui_mg_speattrandwn";

//const int VFX_THIRST_DEATH = 939;


// _________________
// ** Prototypes ***
// -----------------

// Gets if Thirst has been initialized for oTarget.
int GetThirstInitialized(object oTarget);
// Initializes thirst for oTarget.
void InitializeThirst(object oTarget);

// Changes to Thirst Points should all route through here.
void SetThirstPoints(object oTarget, float fQty);
// Gets the thirst-points of oTarget.
float GetThirstPoints(object oTarget);
// Converts thirst-points to a particular stage.
int ThirstPointsToStage(float fQty);
// Thirst Stage is auto-updated when Thirst Points is updated. Do not update manually!
void SetThirstStage(object oTarget, int iStage);
// Gets the thirst-stage of oTarget.
int GetThirstStage(object oTarget);
// Gets if oTarget is died of Thirst.
int GetThirstDead(object oTarget);
// Applies thirst-stage to oTarget.
void ApplyThirstStage(object oTarget, int iStage);
// Clears thirst-effects for oTarget.
void ClearThirstEffects(object oTarget);
// Applies thirst-death to oTarget.
void ApplyThirstDeath(object oTarget);

// Checks for and updates characters if raised after a thirst-death.
void CheckRaisedAfterThirstDeath();
// Checks for and updates oTarget if raised after a thirst-death.
//int CheckRaisedAfterThirstDeath(object oTarget);

// Loses thirst-points for oTarget every hour.
void UpdateThirstPointsPerHour(object oTarget, int iHoursPassed);
// Changes the current thirst-points for oTarget.
void UpdateThirstPoints(object oTarget, float fPoints);

// Gets if the thirst-bar is paused.
int GetThirstBarPaused(object oTarget);
// Gets if the thirst-bar is force-paused.
int GetThirstBarPausedForce(object oTarget);
// Checks if it's okay to pause/unpause Thirst and if so pauses/unpauses.
void ThirstBarPauseRequest(object oTarget, int bPause, int bForced = FALSE);
// Reflects thirst-pause on the GUI.
void ThirstBarPauseToggle(object oTarget, int bPause);
// Checks if Thirst should be paused.
void CheckForThirstPause();
// Checks if faction of oTarget is in conversation.
int GetIsFactionInConversation(object oTarget);

// Handles players switching control of characters.
void HandleThirstPlayerControl();


// GUI

// Closes both thirst-bar screens.
void ClearThirstBarScreens(object oTarget);

// Closes the thirst-bar for oTarget.
void CloseThirstBar(object oTarget);
// Displays the thirst-bar GUI for oTarget.
void DisplayThirstBar(object oTarget);

// Gets the currently displayed GUI-screen for oTarget.
string GetThirstBarScreen(object oTarget);
// Gets the currently displayed GUI-file for oTarget.
string GetThirstBarFile(object oTarget);




// ________________
// ** Functions ***
// ----------------

// Gets if Thirst has been initialized for oTarget.
int GetThirstInitialized(object oTarget)
{
	return GetLocalInt(oTarget, VAR_THIRST_INITIALIZED_b);
}

// Initializes thirst for oTarget.
void InitializeThirst(object oTarget)
{
	if (!GetThirstInitialized(oTarget))
	{
		SetLocalInt(oTarget, VAR_THIRST_INITIALIZED_b, TRUE);
		SetLocalFloat(oTarget, VAR_THIRST_POINTS_f, THIRST_POINTS_START_f);
//		SetLocalFloat(oTarget, VAR_THIRST_POINTS_f, IntToFloat(Random(50) + 50)); // TEST.
	}
}

// Changes to Thirst Points should all route through here.
void SetThirstPoints(object oTarget, float fQty)
{
//	Tell("SetThirstPoints() " + GetName(oTarget));

	if		(fQty > THIRST_POINTS_MAX_f) fQty = THIRST_POINTS_MAX_f;
	else if	(fQty < THIRST_POINTS_MIN_f) fQty = THIRST_POINTS_MIN_f;


	SetLocalFloat(oTarget, VAR_THIRST_POINTS_f, fQty);

	int iStage = ThirstPointsToStage(fQty);
	SetThirstStage(oTarget, iStage);

	if (GetIsPC(oTarget))
	{
		// update the GUI-panel with the new thirst-point level
		float fPercent = fQty / THIRST_POINTS_MAX_f;

		string sScreen = GetThirstBarScreen(oTarget);
		SetGUIProgressBarPosition(oTarget, sScreen, BAR_THIRSTBAR, fPercent);
		SetGUIProgressBarPosition(oTarget, sScreen, BAR_THIRSTBAR_PAUSE, fPercent);

		string sPercent = IntToString(FloatToInt(fPercent * 100.f));
		SetGUIObjectText(oTarget, sScreen, BAR_THIRST_TEXT_PERCENT, -1, sPercent);

		// set the stage icon.
		//SetGUIObjectDisabled(oTarget, sScreen, ICON_THIRST_STAGE_0, iStage <= 0);

		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_1, iStage < 1);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_2, iStage < 2);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_3, iStage < 3);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_4, iStage < 4);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_5, iStage < 5);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_6, iStage < 6);

		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_1_GHOSTED, iStage >= 1);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_2_GHOSTED, iStage >= 2);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_3_GHOSTED, iStage >= 3);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_4_GHOSTED, iStage >= 4);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_5_GHOSTED, iStage >= 5);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_6_GHOSTED, iStage >= 6);

		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_1_TOP, iStage != 1);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_2_TOP, iStage != 2);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_3_TOP, iStage != 3);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_4_TOP, iStage != 4);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_5_TOP, iStage != 5);
		SetGUIObjectHidden(oTarget, sScreen, ICON_THIRST_STAGE_6_TOP, iStage != 6);
	}
}

// Gets the thirst-points of oTarget.
float GetThirstPoints(object oTarget)
{
	return GetLocalFloat(oTarget, VAR_THIRST_POINTS_f);
}

// Converts thirst-points to a particular stage.
// Thirst points are measured on a scale from 0.f to 100.f.
// Thirst Stage is 0 (ok) to 6 (dead).
int ThirstPointsToStage(float fQty)
{
	if (fQty >= THIRST_POINTS_STAGE_0_f) return THIRST_STAGE_0_i;
	if (fQty >= THIRST_POINTS_STAGE_1_f) return THIRST_STAGE_1_i;
	if (fQty >= THIRST_POINTS_STAGE_2_f) return THIRST_STAGE_2_i;
	if (fQty >= THIRST_POINTS_STAGE_3_f) return THIRST_STAGE_3_i;
	if (fQty >= THIRST_POINTS_STAGE_4_f) return THIRST_STAGE_4_i;
	if (fQty >= THIRST_POINTS_STAGE_5_f) return THIRST_STAGE_5_i;

	return THIRST_STAGE_6_i;
}

// Thirst Stage is auto-updated when Thirst Points is updated. Do not update manually!
void SetThirstStage(object oTarget, int iStage)
{
	int iThirst = GetThirstStage(oTarget);
	if (iThirst != iStage) // || iThirst == THIRST_STAGE_6_i)
	{
		SetLocalInt(oTarget, VAR_THIRST_STAGE_i, iStage);
		ApplyThirstStage(oTarget, iStage);

/*		if (iStage < iThirst)
			PlaySound(SFX_THIRST_STAGE_INCREASE);
		else if (iStage > iThirst)
			PlaySound(SFX_THIRST_STAGE_DECREASE); */
	}
}

// Gets the thirst-stage of oTarget.
int GetThirstStage(object oTarget)
{
	return GetLocalInt(oTarget, VAR_THIRST_STAGE_i);
}

// Gets if oTarget is died of Thirst.
int GetThirstDead(object oTarget)
{
	return GetLocalInt(oTarget, VAR_THIRST_DEATH_b);
}

// Applies thirst-stage to oTarget.
void ApplyThirstStage(object oTarget, int iStage)
{
	ClearThirstEffects(oTarget);

//	Tell("ApplyThirstStage() " + GetName(oTarget) + " stage= " + IntToString(iStage));

	int iVal = 0;
	switch (iStage)
	{
//		case THIRST_STAGE_0_i: break;

		case THIRST_STAGE_1_i: iVal = 1; break;
		case THIRST_STAGE_2_i: iVal = 2; break;
		case THIRST_STAGE_3_i: iVal = 3; break;
		case THIRST_STAGE_4_i: iVal = 5; break;
		case THIRST_STAGE_5_i: iVal = 8; break;

		case THIRST_STAGE_6_i:
			ApplyThirstDeath(oTarget);
	}

	if (iVal != 0)
	{
		// NOTE: Tests show these safeties are not needed.
		// POSSIBLE: Shunt things straight to thirst-death if an ability reaches < 1.
/*		int iDisability = GetAbilityScore(oTarget, ABILITY_STRENGTH);
		if (iVal < iDisability)	iDisability = iVal;
		else					iDisability = iDisability - 1;
		effect eStr = EffectAbilityDecrease(ABILITY_STRENGTH, iDisability);

		iDisability = GetAbilityScore(oTarget, ABILITY_DEXTERITY);
		if (iVal < iDisability)	iDisability = iVal;
		else					iDisability = iDisability - 1;
		effect eDex = EffectAbilityDecrease(ABILITY_DEXTERITY, iDisability);

		iDisability = GetAbilityScore(oTarget, ABILITY_CONSTITUTION);
		if (iVal < iDisability)	iDisability = iVal;
		else					iDisability = iDisability - 1;
		effect eCon = EffectAbilityDecrease(ABILITY_CONSTITUTION, iDisability);

		iDisability = GetAbilityScore(oTarget, ABILITY_INTELLIGENCE);
		if (iVal < iDisability)	iDisability = iVal;
		else					iDisability = iDisability - 1;
		effect eInt = EffectAbilityDecrease(ABILITY_INTELLIGENCE, iDisability);

		iDisability = GetAbilityScore(oTarget, ABILITY_WISDOM);
		if (iVal < iDisability)	iDisability = iVal;
		else					iDisability = iDisability - 1;
		effect eWis = EffectAbilityDecrease(ABILITY_WISDOM, iDisability);

		iDisability = GetAbilityScore(oTarget, ABILITY_CHARISMA);
		if (iVal < iDisability)	iDisability = iVal;
		else					iDisability = iDisability - 1;
		effect eChr = EffectAbilityDecrease(ABILITY_CHARISMA, iDisability); */

		effect eStr = EffectAbilityDecrease(ABILITY_STRENGTH, iVal);
		effect eDex = EffectAbilityDecrease(ABILITY_DEXTERITY, iVal);
		effect eCon = EffectAbilityDecrease(ABILITY_CONSTITUTION, iVal);
		effect eInt = EffectAbilityDecrease(ABILITY_INTELLIGENCE, iVal);
		effect eWis = EffectAbilityDecrease(ABILITY_WISDOM, iVal);
		effect eChr = EffectAbilityDecrease(ABILITY_CHARISMA, iVal);

		effect eEffect = EffectLinkEffects(eStr, eDex);
		eEffect = EffectLinkEffects(eEffect, eCon);
		eEffect = EffectLinkEffects(eEffect, eInt);
		eEffect = EffectLinkEffects(eEffect, eWis);
		eEffect = EffectLinkEffects(eEffect, eChr);

		switch (iStage)
		{
			case THIRST_STAGE_4_i:
			case THIRST_STAGE_5_i:
			{
				effect eSlow = EffectSlow();
				eEffect = EffectLinkEffects(eEffect, eSlow);
			}
		}

		eEffect = SupernaturalEffect(eEffect);
		eEffect = SetEffectSpellId(eEffect, THIRST_EFFECT_ID);

/*		Tell("ITERATE EFFECTS");
		effect eTest = GetFirstEffect(oTarget);
		while (GetIsEffectValid(eTest))
		{
			Tell(". effect= " + IntToString(GetEffectType(eTest)));
			eTest = GetNextEffect(oTarget);
		} */

//		Tell(". . apply Effects");
		DelayCommand(0.f, ApplyEffectToObject(DURATION_TYPE_PERMANENT, eEffect, oTarget));
	}
}
/*{
	string sResref = "n2_it_creitem_se" + IntToString(iStage); // NOTE: Creature-skins bug ArmorCheckPenalty.

	object oOldSkin = GetItemInSlot(INVENTORY_SLOT_CARMOUR, oTarget);

	switch (iStage)
	{
		case THIRST_STAGE_0_i:
			if (GetIsObjectValid(oOldSkin))
			{
				DestroyObject(oOldSkin, 0.f, FALSE);
				DelayCommand(1.f, ExecuteScript("ka_se_equip_check", oTarget));
			}
			break;

		case THIRST_STAGE_1_i:
		case THIRST_STAGE_2_i:
		case THIRST_STAGE_3_i:
		case THIRST_STAGE_4_i:
		case THIRST_STAGE_5_i:
			if (GetResRef(oOldSkin) != sResref)
			{
				DestroyObject(oOldSkin, 0.f, FALSE);
				object oSkin = CreateItemOnObject(sResref, oTarget, 1, "", FALSE);
				AssignCommand(oTarget, ActionEquipItem(oSkin, INVENTORY_SLOT_CARMOUR));
				DelayCommand(1.f, ExecuteScript("ka_se_equip_check", oTarget));
			}
			break;

		case THIRST_STAGE_6_i:
			ApplyThirstDeath(oTarget);
			break;
	}
} */

// Clears thirst-effects for oTarget.
void ClearThirstEffects(object oTarget)
{
//	Tell("ClearThirstEffects() " + GetName(oTarget));

	effect eEffect = GetFirstEffect(oTarget);
	while (GetIsEffectValid(eEffect))
	{
		if (GetEffectSpellId(eEffect) == THIRST_EFFECT_ID)
		{
			RemoveEffect(oTarget, eEffect);
			eEffect = GetFirstEffect(oTarget);
		}
		else
			eEffect = GetNextEffect(oTarget);
	}
}

// Applies thirst-death to oTarget.
void ApplyThirstDeath(object oTarget)
{
//	Tell("ApplyThirstDeath() " + GetName(oTarget));

	SetLocalInt(oTarget, VAR_THIRST_DEATH_b, TRUE); // set the variable so scripts know it was a thirst-death

/*	if (GetIsSinglePlayer())
	{
		string sRoster = GetFirstRosterMember(); // remove all roster members so that PC cannot change their player selection
		while (sRoster != "")
		{
			RemoveRosterMemberFromParty(sRoster, oTarget, TRUE);
			sRoster = GetNextRosterMember();
		}

		int i = 1;
		object oHench = GetHenchman(oTarget, i);
		while (GetIsObjectValid(oHench))
		{
			DestroyObject(oHench);
			oHench = GetHenchman(oTarget, ++i);
		}
	}
	else */
	AssignCommand(oTarget, SetIsDestroyable(FALSE, TRUE, TRUE));

//	effect eVis = EffectVisualEffect(VFX_THIRST_DEATH);
//	ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);

	effect eDeath = EffectDeath(FALSE, TRUE, TRUE);
	ApplyEffectToObject(DURATION_TYPE_INSTANT, eDeath, oTarget);
}

// Checks for and updates characters if raised after a thirst-death.
void CheckRaisedAfterThirstDeath()
{
//	Tell("CheckRaisedAfterThirstDeath()");

	object oFaction;
	object oPC = GetFirstPC(FALSE);
	while (GetIsObjectValid(oPC))
	{
		oFaction = GetFirstFactionMember(oPC, FALSE);
		while (GetIsObjectValid(oFaction))
		{
			if (GetThirstDead(oFaction) && GetCurrentHitPoints(oFaction) > 0)
			{
				SetLocalInt(oFaction, VAR_THIRST_DEATH_b, FALSE);
				ClearThirstEffects(oFaction);

				int iHpDesired = (GetHitDice(oFaction) * 4) + 1; // Max. ability-penalty is 8, so 4-hp is max. loss per level by Constitution.

				int iHp = GetCurrentHitPoints(oFaction);
				if (iHp < iHpDesired)
				{
					int iHeal = iHpDesired - iHp;
					effect eHeal = EffectHeal(iHeal);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eHeal, oFaction); // character is likely about to get hit with a Con drop, so throw a bone.
				}

				// NOTE: Healed points are not applied instantly in script, so fudge it
				int iHpProjected;
				if (iHp > iHpDesired) iHpProjected = iHp;
				else iHpProjected = iHpDesired;

				float fQty = 100.f * IntToFloat(iHpProjected) / IntToFloat(GetMaxHitPoints(oFaction));
				if (fQty < 5.f) fQty = 5.f;

				SetThirstPoints(oFaction, fQty);
			}
			oFaction = GetNextFactionMember(oPC, FALSE);
		}
		oPC = GetNextPC(FALSE);
	}
}

// Loses thirst-points for oTarget every hour.
void UpdateThirstPointsPerHour(object oTarget, int iHoursPassed)
{
	if (GetThirstInitialized(oTarget)
		&& !GetThirstBarPaused(oTarget)
		&& !GetThirstBarPausedForce(oTarget))
	{
		float fLostPoints = IntToFloat(iHoursPassed) * THIRST_HOURLY_DECAY_f;
		UpdateThirstPoints(oTarget, fLostPoints);
	}
}

// Changes the current thirst-points for oTarget.
void UpdateThirstPoints(object oTarget, float fPoints)
{
	SetThirstPoints(oTarget, GetThirstPoints(oTarget) + fPoints);
}

// Gets if the thirst-bar is paused.
int GetThirstBarPaused(object oTarget)
{
	return GetLocalInt(oTarget, VAR_THIRST_PAUSED_b);
}

// Gets if the thirst-bar is force-paused.
int GetThirstBarPausedForce(object oTarget)
{
	return GetLocalInt(oTarget, VAR_THIRST_PAUSED_FORCE_b);
}

// Checks if it's okay to pause/unpause Thirst and if so pauses/unpauses.
void ThirstBarPauseRequest(object oTarget, int bPause, int bForced = FALSE)
{
	if (bForced == TRUE)
	{
		// NOTE: Only initialized TruePCs should get in here.
		if (bPause == TRUE)
			SetLocalInt(oTarget, VAR_THIRST_PAUSED_FORCE_b, TRUE);
		else
			DeleteLocalInt(oTarget, VAR_THIRST_PAUSED_FORCE_b);

		ThirstBarPauseToggle(oTarget, bPause);
	}
	else if (GetThirstInitialized(oTarget) && GetThirstBarPaused(oTarget) != bPause)
	{
//		Tell("pause " + GetName(oTarget)); // debug.

		SetLocalInt(oTarget, VAR_THIRST_PAUSED_b, bPause);

		if (GetIsPC(oTarget))
			ThirstBarPauseToggle(oTarget, bPause);
	}
}

// Reflects thirst-pause on the GUI.
void ThirstBarPauseToggle(object oTarget, int bPause)
{
//	Tell(". swap ghosting " + GetName(oTarget)); // debug.

	string sScreen = GetThirstBarScreen(oTarget);
	SetGUIObjectHidden(oTarget, sScreen, BAR_THIRSTBAR,    bPause);
	SetGUIObjectHidden(oTarget, sScreen, BAR_THIRSTBAR_BG, bPause);

	SetGUIObjectHidden(oTarget, sScreen, BAR_THIRSTBAR_PAUSE,    !bPause);
	SetGUIObjectHidden(oTarget, sScreen, BAR_THIRSTBAR_BG_PAUSE, !bPause);
}

// Checks if Thirst should be paused.
void CheckForThirstPause()
{
	int bPause;

	object oFaction;
	object oPC = GetFirstPC(FALSE);
	while (GetIsObjectValid(oPC))
	{
		if (!GetLocalInt(oPC, "thirst_iter"))
		{
			SetLocalInt(oPC, "thirst_iter", TRUE);

			if (GetIsFactionInConversation(oPC))
				bPause = TRUE;
			else
				bPause = FALSE;

			oFaction = GetFirstFactionMember(oPC, FALSE);
			while (GetIsObjectValid(oFaction))
			{
				if (GetAssociateType(oFaction) == ASSOCIATE_TYPE_NONE
					&& !GetThirstBarPausedForce(oFaction))
				{
					ThirstBarPauseRequest(oFaction, bPause);
				}
				oFaction = GetNextFactionMember(oPC, FALSE);
			}
		}
		oPC = GetNextPC(FALSE);
	}

	oPC = GetFirstPC(FALSE);
	while (GetIsObjectValid(oPC))
	{
		DeleteLocalInt(oPC, "thirst_iter");
		oPC = GetNextPC(FALSE);
	}
}

// Checks if faction of oTarget is in conversation.
int GetIsFactionInConversation(object oTarget)
{
	object oFaction = GetFirstFactionMember(oTarget, FALSE);
	while (GetIsObjectValid(oFaction))
	{
		if (IsInConversation(oFaction))
			return TRUE;

		oFaction = GetNextFactionMember(oTarget, FALSE);
	}
	return FALSE;
}

// Handles players switching control of characters.
// This is only to update the UI.
// TODO: This does not have to cycle through all players; instead it could
// deal with only the character losing control in 'gb_comp_usrdef' and
// 'gb_assoc_usrdef', and the character gaining control in 'gb_player_ud'.
void HandleThirstPlayerControl()
{
	object oPC = GetFirstPC(FALSE);
	while (GetIsObjectValid(oPC))
	{
		ClearThirstBarScreens(oPC);

		if (GetAssociateType(oPC) == ASSOCIATE_TYPE_NONE) // ie. not ASSOCIATE_TYPE_FAMILIAR
		{
			DisplayThirstBar(oPC);
			SetThirstPoints(oPC, GetThirstPoints(oPC));
		}
		oPC = GetNextPC(FALSE);
	}
}


// GUI

// Closes both thirst-bar screens.
// Called when player switches character-control, which relies on all Companions
// firing 'gb_comp_usrdef' in their on-User-Defined event slots.
//
// TODO: Control of familiars needs to be investigated.
void ClearThirstBarScreens(object oTarget)
{
	CloseGUIScreen(oTarget, SCREEN_GUI_THIRST_BAR_s);
	CloseGUIScreen(oTarget, SCREEN_GUI_THIRST_BAR_MIN_s);
}

// Closes the thirst-bar for oTarget.
void CloseThirstBar(object oTarget)
{
	CloseGUIScreen(oTarget, GetThirstBarScreen(oTarget));
}

// Displays the thirst-bar GUI for oTarget.
void DisplayThirstBar(object oTarget)
{
	string sScreen = GetThirstBarScreen(oTarget);
	string sFile = GetThirstBarFile(oTarget);

	DisplayGuiScreen(oTarget, sScreen, FALSE, sFile);
}

// Gets the currently displayed GUI-screen for oTarget.
string GetThirstBarScreen(object oTarget)
{
	string sScreen = GetLocalString(oTarget, VAR_THIRST_BAR_SCREEN_s);
	if (sScreen == "") // init to maximized bar
		return SCREEN_GUI_THIRST_BAR_s;

	return sScreen;
}

// Gets the currently displayed GUI-file for oTarget.
string GetThirstBarFile(object oTarget)
{
	string sFile = GetLocalString(oTarget, VAR_THIRST_BAR_FILE_s);
	if (sFile == "") // init to maximized bar
		return FILE_GUI_THIRST_BAR_s;

	return sFile;
}
