// 'onrest_tst_food'
/*
	This script should be used as a "On Player Rest Script".
	It checks that the PC's party all have food in their inventories.
	If they don't, then no one can rest.
*/
// Created on : January 14th 2007.


void main()
{
	object oPC = GetLastPCRested();

	switch (GetLastRestEventType())
	{
		case REST_EVENTTYPE_REST_STARTED:
		{
			// Look for food-type items in party's inventory.
			int bCancel = FALSE;

			object oFaction = GetFirstFactionMember(oPC, FALSE);
			while (GetIsObjectValid(oFaction) && bCancel == FALSE)
			{
				if (GetAssociateType(oFaction) == ASSOCIATE_TYPE_NONE)
				{
					bCancel = TRUE;

					object oFood = GetFirstItemInInventory(oFaction);
					while (GetIsObjectValid(oFood))
					{
						if (GetTag(oFood) == "foodForRest")
						{
							bCancel = FALSE;
							break;
						}
						oFood = GetNextItemInInventory(oFaction);
					}
				}
				oFaction = GetNextFactionMember(oPC, FALSE);
			}

			if (bCancel == TRUE)
			{
				AssignCommand(oPC, ClearAllActions());
				AssignCommand(oPC, SpeakString("You cannot rest unless everyone in the party has some food."));
			}
/*			else // NOTE: Enable this block and disable it in REST_EVENTTYPE_REST_FINISHED below to consume food even if rest is cancelled.
			{
				object oFaction = GetFirstFactionMember(oPC, FALSE);
				while (GetIsObjectValid(oFaction))
				{
					if (GetAssociateType(oFaction) == ASSOCIATE_TYPE_NONE)
					{
						object oFood = GetFirstItemInInventory(oFaction);
						while (GetIsObjectValid(oFood))
						{
							if (GetTag(oFood) == "foodForRest")
							{
								int iStackSize = GetItemStackSize(oFood);
								if (iStackSize == 1)
									DestroyObject(oFood);
								else
									SetItemStackSize(oFood, iStackSize - 1);

								break;
							}
							oFood = GetNextItemInInventory(oFaction);
						}
					}
					oFaction = GetNextFactionMember(oPC, FALSE);
				}
			} */
			break;
		}

//		case REST_EVENTTYPE_REST_CANCELLED:
//			break;

		case REST_EVENTTYPE_REST_FINISHED: // NOTE: This allows a bit of an exploit if player cancels rest before it finishes.
		{
			object oFaction = GetFirstFactionMember(oPC, FALSE);
			while (GetIsObjectValid(oFaction))
			{
				if (GetAssociateType(oFaction) == ASSOCIATE_TYPE_NONE)
				{
					object oFood = GetFirstItemInInventory(oFaction);
					while (GetIsObjectValid(oFood))
					{
						if (GetTag(oFood) == "foodForRest")
						{
							int iStackSize = GetItemStackSize(oFood);
							if (iStackSize == 1)
								DestroyObject(oFood);
							else
								SetItemStackSize(oFood, iStackSize - 1);

							break;
						}
						oFood = GetNextItemInInventory(oFaction);
					}
				}
				oFaction = GetNextFactionMember(oPC, FALSE);
			}
		}
	}
}
